<%-- 
	Gentics .Node PortalConnector - JSP Example

	A simple example to output Contents of pages or binarycontent of files.
--%>
<%@page import="com.gentics.api.portalnode.connector.PortalConnectorHelper" %>
<%@page import="com.gentics.api.portalnode.connector.PortalConnectorFactory" %>
<%@page import="com.gentics.api.portalnode.connector.PLinkInformation" %>
<%@page import="com.gentics.api.portalnode.connector.PLinkReplacer" %>
<%@page import="com.gentics.api.lib.datasource.Datasource" %>
<%@page import="com.gentics.api.lib.resolving.Resolvable" %>
<%
	// Load the properties from the given file...
	java.util.Properties props = new java.util.Properties();
	props.load(getServletContext().getResourceAsStream("pc/handle.properties"));
	// ... and create the datasource.
	Datasource ds = PortalConnectorFactory.createDatasource(props);

	String contentid = (String)request.getParameter("contentid");
	if(contentid == null) { contentid = props.getProperty("startcontentid"); }
	Resolvable contentObject = PortalConnectorFactory.getContentObject(contentid, ds);

	// Make sure we found an object.
	if(contentObject != null) {
	    if("10008".equals(contentObject.get("obj_type").toString())) {
		    // If we got a file, output binarydata.
	        response.setContentType((String)contentObject.get("mimetype"));
			response.getOutputStream().write((byte[])contentObject.get("binarycontent"));
			response.getOutputStream().flush();
			response.getOutputStream().close();
			return;
	    } else {
	        // Otherwise print content of the page.
		    String content = (String)contentObject.get("content");
		    if(content != null) {
		        // Replace <plink ...>s
			    content = PortalConnectorHelper.replacePLinks(content, new PLinkReplacer() {
			        public String replacePLink(PLinkInformation plink) {
			            return "?contentid=" + plink.getContentId();
			        }
			    });
		        // Finally print out the content..
				response.getWriter().println(content);
		    } else {
		        throw new java.io.FileNotFoundException("Page contains no content.");
		    }
	    }
	} else {
	    // Otherwise throw an exception.
	    throw new java.io.FileNotFoundException("No Page found with contentid " + contentid);
	}
%>